# coding: utf-8

"""
    GraphScope Interactive API v0.3

    This is the definition of GraphScope Interactive API, including   - AdminService API   - Vertex/Edge API   - QueryService   AdminService API (with tag AdminService) defines the API for GraphManagement, ProcedureManagement and Service Management.  Vertex/Edge API (with tag GraphService) defines the API for Vertex/Edge management, including creation/updating/delete/retrive.  QueryService API (with tag QueryService) defines the API for procedure_call, Ahodc query. 

    The version of the OpenAPI document: 1.0.0
    Contact: graphscope@alibaba-inc.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictStr
from pydantic import Field
from gs_interactive.models.model_property import ModelProperty
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class DeleteEdgeRequest(BaseModel):
    """
    DeleteEdgeRequest
    """ # noqa: E501
    edge_label: Optional[StrictStr] = Field(default=None, description="The label name of the edge.")
    src_label: Optional[StrictStr] = Field(default=None, description="The label name of the source vertex.")
    dst_label: Optional[StrictStr] = Field(default=None, description="The label name of the destination vertex.")
    src_primary_key_values: Optional[List[ModelProperty]] = Field(default=None, description="Primary key values for the source vertex.")
    dst_primary_key_values: Optional[List[ModelProperty]] = Field(default=None, description="Primary key values for the destination vertex.")
    __properties: ClassVar[List[str]] = ["edge_label", "src_label", "dst_label", "src_primary_key_values", "dst_primary_key_values"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of DeleteEdgeRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in src_primary_key_values (list)
        _items = []
        if self.src_primary_key_values:
            for _item in self.src_primary_key_values:
                if _item:
                    _items.append(_item.to_dict())
            _dict['src_primary_key_values'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in dst_primary_key_values (list)
        _items = []
        if self.dst_primary_key_values:
            for _item in self.dst_primary_key_values:
                if _item:
                    _items.append(_item.to_dict())
            _dict['dst_primary_key_values'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of DeleteEdgeRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "edge_label": obj.get("edge_label"),
            "src_label": obj.get("src_label"),
            "dst_label": obj.get("dst_label"),
            "src_primary_key_values": [ModelProperty.from_dict(_item) for _item in obj.get("src_primary_key_values")] if obj.get("src_primary_key_values") is not None else None,
            "dst_primary_key_values": [ModelProperty.from_dict(_item) for _item in obj.get("dst_primary_key_values")] if obj.get("dst_primary_key_values") is not None else None
        })
        return _obj


